var/const/BLOCK_LAYER = 10

world
	view = 5

area
	icon = 'green.dmi'

mob
	icon = 'mob.dmi'

	Move()
		. = ..()
		if(client && .) client.UpdateViewFilter()

turf
	var
		image/viewblock

	New()
		..()
		viewblock = image('blackblock.dmi',src,,BLOCK_LAYER)

client
	var/list
		ViewFilter = list()
		SeenTurfs = list()

	New()
		..()
		SeenTurfs = list()

	proc/UpdateViewFilter()
		var
			Image
			turf/oneway/Oneway
			list
				newimages = list()
				v = view(world.view,mob)
				onewaylist = list()

		for(Oneway in v)
			if(Oneway.dir & get_dir(Oneway,mob))
				Oneway.opacity = 1
				onewaylist += Oneway

		if(onewaylist.len)
			var/list/List = v - view(world.view,mob)
			for(var/turf/T in List)
				src << T.viewblock
				newimages += T.viewblock

			for(Oneway in onewaylist)
				Oneway.opacity = 0

		for(Image in ViewFilter-newimages)
			images -= Image
		ViewFilter = newimages

turf
	wall
		icon = 'wall.dmi'
		opacity = 1

	oneway
		icon = 'onewayview.dmi'
